


/*
** Ldap_auth
** $Id: ldap_auth.c,v 1.3 2000/04/12 14:33:49 simon Exp $
** Copyright (c) Pavilion Internet Plc 1998,1999,2000 
** written by Simon Loader simon@surf.org.uk, simon@loaders.net
**
**  	Simon Mon Oct 19 09:28:19 BST 1998
**  An authentication program for squid. Should 
** autheticate against an ldap server (I hope).
** Takes arguments on stdin of 
** username password (check squid docs)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define BUFSIZE	256

void usage(char *);
static char *copyright = "$Id$ Copyright (c) Simon Loader 1998-2000 written by Simon Loader simon@surf.org.uk, simon@loaders.net";


/* defaults for settings
*/
#define MY_LDAP_SERVER  "127.0.0.1"
#define MY_LDAP_BASEDN  "o=SURF, c=UK"
#define MY_LDAP_UIDATTR "dn"
#define MY_PORT	389



int main(int argc, char *argv[])
{
	int i, isvalid;
	char buf[BUFSIZE];
	char *p, *user, *passwd;

/*
** options
** LDAP_SERVER  "127.0.0.1" 		-h
** port ldap server on			-p
** LDAP_BASEDN  "o=NINAA, c=UK"		-b
** LDAP_UIDATTR "uid"			-a
** Look at man 3 getopt
*/
int opt;
extern char *optarg;
extern int optind;

char *ldap_server = 0;
int ldap_port = MY_PORT;
char *ldap_basedn = 0;
char *ldap_attrib = 0;

char *default_ldap_server = MY_LDAP_SERVER;
char *default_ldap_basedn = MY_LDAP_BASEDN;
char *default_ldap_attrib = MY_LDAP_UIDATTR;

while ((opt = getopt(argc, argv, "h:p:b:a:")) != -1)
	{
	switch(opt)
		{
		case 'h':
			ldap_server = optarg;
			break;
		case 'p':
			ldap_port = atoi(optarg);
			break;
		case 'b':
			ldap_basedn = optarg;
			break;
		case 'a':
			ldap_attrib = optarg;
			break;
		case '?':
		default:
			/* some uasge stuff */
			usage(argv[0]);
		}
	}

	if (!ldap_server)
		{
		ldap_server = default_ldap_server;
		}
	if (!ldap_attrib)
		{
		ldap_attrib = default_ldap_basedn;
		}
	if (!ldap_basedn)
		{
		ldap_basedn = default_ldap_attrib;
		}
	
	/* make standard output line buffered */
	if (setvbuf(stdout, NULL, _IOLBF, 0) != 0)
		return;
	while (fgets(buf, BUFSIZE, stdin) !=NULL ) {
		/* stop " " in front of user name */
		if ( (p = strchr(buf, ' ')) == buf )
			{
			printf("ERR\n");
			continue;
			}
		if ((p = strchr(buf, '\n')) != NULL)
			{
			*p = '\0';		/* strip \n */
			}
		if ((user = strtok(buf, " ")) == NULL)
			{
			printf("ERR\n");
			continue;
			}
		if ((passwd = strtok(NULL, "")) == NULL)
			{
			printf("ERR\n");
			continue;
			}
		if ( pwcheck(user,passwd,ldap_server,ldap_basedn,ldap_attrib,ldap_port) )
			{
			printf("OK\n");
			}
		else
			{
			printf("ERR\n");
			}
		}
}



void usage(char *progname)
{
	fprintf(stderr, 
	"usage: %s [-h ldap server] [-p port] [-b base dn ] [-a attribute]\n",progname);
	fprintf(stderr, "eg. %s -h 127.0.0.1 -b \"o=NINAA, c=UK\" -a \"uid\"\n",progname);
	exit(0);
}

